# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.0'

from Globals import HTML,HTMLFile,MessageDialog
from Globals import DTMLFile
from ImageFile import ImageFile  

import Globals, sys, traceback

from OFS.Folder import Folder
from AccessControl import getSecurityManager

from AccessControl import ClassSecurityInfo
from AccessControl.Role import RoleManager


import os,stat,string,posixfile
import sys, traceback

from Xindice import Xindice

from xml.xslt.Processor import Processor

manage_add_doc_Form = HTMLFile('dtml/add_doc_form', globals())
default_doc="""
"""



def manage_add_doc(self, id='',title='',server='', collection="", query="", style="" , REQUEST=None, submit=None):
    """Add a Xindice """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_doc_form',)
    #create new object instance
    id=str(id)
    title=str(title)
    ob=XindiceDocument( id, title)
    ob.default_doc = default_doc
    ob.query=query    
    ob.collection=collection  
    ob.server=server
    ob.style=style
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'


class XindiceDocument(Folder):
    """ Zope Product object."""    

    meta_type = 'Xindice'

    """
    C a doit etre cool d'etre CRS, mo j'ai ete recal alors je fais
    du Zope :(
    """
    security=ClassSecurityInfo()

    _properties=(
{'id':'title', 'type':'string','mode':'w'},
{'id':'server', 'type':'string','mode':'w'},
{'id':'query', 'type':'string','mode':'w'},
{'id':'collection', 'type':'string','mode':'w'},
{'id':'style', 'type':'string','mode':'w'},
)


    manage_opt = HTMLFile('dtml/manage_folder_options', globals())

    manage_options= Folder.manage_options + (
	{'label' : 'Edit', 'action' : 'manage_form_edit'},
	{'label' : 'Properties', 'action' : 'manage_properties'},
	{'label' : 'API', 'action' : 'help'},
	{'label' : 'Result XML', 'action' : 'manage_view_xml_dtml'},
	{'label' : 'Result HTML', 'action' : 'manage_view_html_dtml'},
	) 



    def __init__(self,id='',title=''):
	"""
	CRS mon reve, coupe droite et ide basse .
	"""
	self.id = id
	self.title = title



    security.declareProtected('View Xindice','view')
    def view(self,server,collection,query,style,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	Result in html with xsl style sheet 
	"""
	self.server = server
	self.collection = collection
	self.query = query
	self.style = style

	res = self.standard_html_header(self, REQUEST)
	objet = getattr(self,self.style)
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.queryCollection('XPath',self.query)
	except:
		data = 'Aill :)'
		
	xsl = objet.absolute_url()
	
	xsltproc = Processor()
	xsltproc.appendStylesheetUri(xsl)

	res = res + xsltproc.runString(data)
	res = res + self.standard_html_footer(self, REQUEST)

	return res
	

    def view_text(self,server,collection,query,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	view text
	"""
	self.server = server
	self.collection = collection
	self.query = query
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.queryCollection('XPath',self.query)
	except:
		data = 'Aill :)'
	
	return data 
 
    def view_text_by_key(self,server,collection,key,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	view text by key
	"""
	self.server = server
	self.collection = collection
	self.key = key
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.queryCollection_key('XPath',self.query,key)
	except:
		data = 'Aill :)'

	return data 
		
    def list_collection(self,server,collection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	list collection
	"""
	self.server = server
	self.collection = collection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.listCollections()
	except:
		data = 'Aill :)'
	
	return data 

    def list_document(self,server,collection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	list document
	"""
	self.server = server
	self.collection = collection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.listDocuments()
	except:
		data  = 'Aill :)'
	
	return  data 


    def count_document(self,server,collection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	count documents
	"""
	self.server = server
	self.collection = collection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.countDocuments()
	except:
		data  = 'Aill :)'
		
	return data 


    def create_collection(self,server,collection,newcollection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	create collection
	"""
	self.server = server
	self.collection = collection
	self.newcollection = newcollection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.createCollections(newcollection)
	except:
		data  = 'Aill :)'
	
	return data 
	
    def remove_collection(self,server,collection,rmcollection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	remove collection
	"""
	self.server = server
	self.collection = collection
	self.rmcollection = rmcollection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.removeCollections(rmcollection)
	except:
		data  = 'Aill :)'
	
	return data 

    def open_document(self,server,collection,document,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	open document
	"""
	self.server = server
	self.collection = collection
	self.document = document
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.openDocument(document)
	except:
		data  = 'Aill :)'
	return data


    def delete_document(self,server,collection,document,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	delete document
	"""
	self.server = server
	self.collection = collection
	self.document = document 
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.deleteDocument(document)
	except:
		data  = 'Aill :)'
	return data 
    
    def insert_document(self,server,collection,name_file,file,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	insert document
	"""
	self.server = server
	self.collection = collection
	self.name_file = name_file
	self.file = file 
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.deleteDocument(name,file)
	except:
		data  = 'Aill :)'

	return data 


    def list_indexer(self,server,collection,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	returns a list of indexer
	"""
	self.server = server
	self.collection = collection
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.listIndexer()
	except:
		data  = 'Aill :)'
		
	return data 

    def create_indexer(self,server,collection,indexe,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	create indexer
	"""
	self.server = server
	self.collection = collection
	self.indexe = indexe
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.createIndexer(indexe,indexe)
	except:
		data  = 'Aill :)'
		
	return data

    def remove_indexer(self,server,collection,indexe,client=None, REQUEST={}, RESPONSE=None, **kw):
	"""
	remove indexer 
	"""
	self.server = server
	self.collection = collection
	self.indexe = indexe
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.removeIndexer(indexe,indexe)
	except:
		data = 'Aill :)'

	return data


    manage_view_xml_dtml = DTMLFile('dtml/manage_text_xml',globals())

    manage_view_html_dtml = DTMLFile('dtml/manage_text_html',globals())

    help = DTMLFile('dtml/manage_help_api',globals())

    manage_propert = DTMLFile('dtml/view_xindice',globals())

    def manage_view_result_xml(self):
	"""
	View the xml result in the ZMI
	"""
	return self.view_text(self.server,self.collection,self.query)

    def manage_view_result_html(self):
        """
	View the html result in the ZMI
	"""
	try:
		cnx = Xindice(self.server,'4080',self.collection)
		data = cnx.queryCollection('XPath',self.query)
	except:
		data = 'Aill :)'
	
	objet = getattr(self,self.style) 
	xsl = objet.absolute_url()
	
        xsltproc = Processor()
	xsltproc.appendStylesheetUri(xsl)


	res =  xsltproc.runString(data)

	return res


    manage_form_edit = DTMLFile('dtml/manage_edit_form',globals())
    
    def manage_edit(self,server,collection,query,style,REQUEST=None):
	"""
	Raymond Bhur 
	"""
	self.server = server
	self.collecion = collection
	self.query = query
	self.style = style
	self._p_changed =  1
	u=REQUEST['URL1']
	REQUEST.RESPONSE.redirect(u+'/manage_main')



Globals.default__class_init__(XindiceDocument)


